org.apache.commons.math3.optimization.general

## Class AbstractDifferentiableOptimizer

- java.lang.Object
- - org.apache.commons.math3.optimization.direct.BaseAbstractMultivariateOptimizer<MultivariateDifferentiableFunction>
  - - org.apache.commons.math3.optimization.general.AbstractDifferentiableOptimizer

- All Implemented Interfaces:
    BaseMultivariateOptimizer<MultivariateDifferentiableFunction>, BaseOptimizer<PointValuePair>

  Deprecated.
  As of 3.1 (to be removed in 4.0).

      @Deprecated
      public abstract class AbstractDifferentiableOptimizer
      extends BaseAbstractMultivariateOptimizer<MultivariateDifferentiableFunction>

  Base class for implementing optimizers for multivariate scalar differentiable functions. It contains boiler-plate code for dealing with gradient evaluation.
  Since:
    3.1
  Version:
    $Id: AbstractDifferentiableOptimizer.java 1422230 2012-12-15 12:11:13Z erans $

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `private MultivariateVectorFunction` | `gradient` Deprecated. Objective function gradient.

    - ### Fields inherited from class org.apache.commons.math3.optimization.direct.BaseAbstractMultivariateOptimizer

      `evaluations`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `AbstractDifferentiableOptimizer(ConvergenceChecker<PointValuePair> checker)` Deprecated.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected double[]` | `computeObjectiveGradient(double[] evaluationPoint)` Deprecated. Compute the gradient vector.
    `protected PointValuePair` | `optimizeInternal(int maxEval, MultivariateDifferentiableFunction f, GoalType goalType, double[] startPoint)` Deprecated. In 3.1. Please use `optimizeInternal(int,MultivariateDifferentiableFunction,GoalType,OptimizationData[])` instead.
    `protected PointValuePair` | `optimizeInternal(int maxEval, MultivariateDifferentiableFunction f, GoalType goalType, OptimizationData... optData)` Deprecated. Optimize an objective function.

    - ### Methods inherited from class org.apache.commons.math3.optimization.direct.BaseAbstractMultivariateOptimizer

      `computeObjectiveValue, doOptimize, getConvergenceChecker, getEvaluations, getGoalType, getLowerBound, getMaxEvaluations, getStartPoint, getUpperBound, optimize, optimize`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### gradient

          private MultivariateVectorFunction gradient

      Deprecated.
      Objective function gradient.

  - ### Constructor Detail

    - #### AbstractDifferentiableOptimizer

          protected AbstractDifferentiableOptimizer(ConvergenceChecker<PointValuePair> checker)

      Deprecated.
      Parameters:
        `checker` - Convergence checker.

  - ### Method Detail

    - #### computeObjectiveGradient

          protected double[] computeObjectiveGradient(double[] evaluationPoint)

      Deprecated.
      Compute the gradient vector.
      Parameters:
        `evaluationPoint` - Point at which the gradient must be evaluated.
      Returns:
        the gradient at the specified point.

    - #### optimizeInternal

          @Deprecated
          protected PointValuePair optimizeInternal(int maxEval,
                                                   MultivariateDifferentiableFunction f,
                                                   GoalType goalType,
                                                   double[] startPoint)

      Deprecated. In 3.1. Please use `optimizeInternal(int,MultivariateDifferentiableFunction,GoalType,OptimizationData[])` instead.
      Optimize an objective function.
      Overrides:
        `optimizeInternal` in class `BaseAbstractMultivariateOptimizer<MultivariateDifferentiableFunction>`
      Parameters:
        `maxEval` - Maximum number of function evaluations.
        `f` - Objective function.
        `goalType` - Type of optimization goal: either `GoalType.MAXIMIZE` or `GoalType.MINIMIZE`.
        `startPoint` - Start point for optimization.
      Returns:
        the point/value pair giving the optimal value for objective function.

    - #### optimizeInternal

          protected PointValuePair optimizeInternal(int maxEval,
                                        MultivariateDifferentiableFunction f,
                                        GoalType goalType,
                                        OptimizationData... optData)

      Deprecated.
      Optimize an objective function.
      Overrides:
        `optimizeInternal` in class `BaseAbstractMultivariateOptimizer<MultivariateDifferentiableFunction>`
      Parameters:
        `maxEval` - Allowed number of evaluations of the objective function.
        `f` - Objective function.
        `goalType` - Optimization type.
        `optData` - Optimization data. The following data will be looked for:
        - `InitialGuess`
        - `SimpleBounds`
      Returns:
        the point/value pair giving the optimal value of the objective function.

Copyright (c) 2003-2013 Apache Software Foundation